=== debian/changelog ===
actor-framework (0.13.2-3) unstable; urgency=medium

  * Fix pkg-config files 

 -- Robert Lemmen <robertle@semistable.com>  Tue, 28 Jul 2015 10:16:04 +0100

actor-framework (0.13.2-2) unstable; urgency=medium

  * Fixed missing build-depends

 -- Robert Lemmen <robertle@semistable.com>  Tue, 21 Jul 2015 09:17:53 +0100

actor-framework (0.13.2-1) unstable; urgency=low

  * Initial release (Closes: #775232)

 -- Robert Lemmen <robertle@semistable.com>  Thu, 22 Jan 2015 20:52:55 +0000
