=== debian/control ===
Source: actor-framework
Priority: optional
Maintainer: Robert Lemmen <robertle@semistable.com>
Build-Depends: debhelper (>= 9), cmake, hevea, texlive-latex-recommended, texlive-latex-base, texlive-fonts-recommended
Standards-Version: 3.9.6
Section: libs
Homepage: http://www.actor-framework.org/

Package: libcaf-dev
Section: libdevel
Architecture: any
Depends: libcaf-core0.13.2 (= ${binary:Version}), libcaf-io0.13.2 (= ${binary:Version}) , ${misc:Depends}
Description: Implementation of the Actor Model in C++, development files
 The actor-framework library facilitates writing applications based on the
 actor model in C++. It aims to be lightweight, distributed and simple.
 .
 This package contains documentation, examples, headers and other files 
 required to develop applications against the library.

Package: libcaf-core0.13.2
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Implementation of the Actor Model in C++, core library
 The actor-framework library facilitates writing applications based on the
 actor model in C++. It aims to be lightweight, distributed and simple.
 .
 This package contains the core library.

Package: libcaf-io0.13.2
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Implementation of the Actor Model in C++, I/O library
 The actor-framework library facilitates writing applications based on the
 actor model in C++. It aims to be lightweight, distributed and simple.
 .
 This package contains the io library required for network transparency.
