=== debian/rules ===
#!/usr/bin/make -f

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

export DEB_CXXFLAGS_MAINT_APPEND = -std=c++11 -pthread

override_dh_auto_configure:
	./configure --prefix=/usr --no-unit-tests

override_dh_auto_build:
	dh_auto_build
	$(MAKE) -C manual

override_dh_clean:
	dh_clean
	rm -f manual/variables.tex
	$(MAKE) -C manual clean

%:
	dh $@
